function Time(timeStr)
{
  var pieces = timeStr.split(":", 2);
  this.hour = Number(pieces[0]);
  this.minute = Number(pieces[1]);
  this.toString = generateString;
  this.before = before;
  this.after = after;

  function before(date)
  {
    if (date.getHours() == this.hour) return this.minute <= date.getMinutes();
    return this.hour < date.getHours();
  }

  function after(date)
  {
    return !this.before(date);
  }

  function generateString(militaryTime) 
  {
    if (isNaN(this.hour) || isNaN(this.minute)) return "---";
    var time = "";
    var isAm = true;
if (!militaryTime) {
    if (this.hour == 0) { time+="12:"; }
    else if (this.hour == 12) { time+="12:"; isAm = false; }
    else if (this.hour > 12) { time+=(this.hour-12)+":"; isAm = false; }
    else { time+=this.hour+":"; }
} else {
    time+=this.hour+":";
}
    time+=((this.minute < 10)?"0":"")+this.minute;
if (!militaryTime) {
    time+=(isAm?" am":" pm");
}
    return time;
  }
}

